VERSION 5.00
Begin VB.Form frmRoman 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Convert a Number to Roman Numerals"
   ClientHeight    =   2880
   ClientLeft      =   4740
   ClientTop       =   4875
   ClientWidth     =   6585
   Icon            =   "frmRoman.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2880
   ScaleWidth      =   6585
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   495
      Left            =   3825
      TabIndex        =   5
      Top             =   2160
      Width           =   2415
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Con&vert"
      Default         =   -1  'True
      Height          =   495
      Left            =   345
      TabIndex        =   4
      Top             =   2160
      Width           =   2415
   End
   Begin VB.TextBox txtNumber 
      Height          =   435
      Left            =   345
      MaxLength       =   4
      TabIndex        =   0
      Top             =   480
      Width           =   5895
   End
   Begin VB.Label lblRoman 
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   345
      TabIndex        =   3
      Top             =   1500
      Width           =   5895
   End
   Begin VB.Label Label2 
      BackStyle       =   0  'Transparent
      Caption         =   "Roman Numeral Equivalent:"
      Height          =   255
      Left            =   345
      TabIndex        =   2
      Top             =   1200
      Width           =   5775
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "Enter a number between 1 and 3999:"
      Height          =   255
      Left            =   345
      TabIndex        =   1
      Top             =   180
      Width           =   5775
   End
End
Attribute VB_Name = "frmRoman"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub txtNumber_GotFocus()
    With txtNumber
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
End Sub

Private Sub txtNumber_KeyPress(KeyAscii As Integer)

    If KeyAscii < 32 Then Exit Sub
    
    If InStr("0123456789", Chr$(KeyAscii)) = 0 Then
        KeyAscii = 0
    End If
    
End Sub

Private Sub txtNumber_Change()
    lblRoman.Caption = ""
End Sub

Private Sub cmdConvert_Click()
    
    If Val(txtNumber.Text) < 1 _
    Or Val(txtNumber.Text) > 3999 Then
        MsgBox "Number out of range. Please enter a number between 1 and 3999.", _
               vbExclamation, _
               "Roman Numerals"
        txtNumber.SetFocus
        Exit Sub
    End If
    
    lblRoman.Caption = ConvertToRoman(txtNumber.Text)

End Sub

Private Sub cmdExit_Click()
    End
End Sub

Private Function ConvertToRoman(pstrDecimalNumber As String) As String

    Const strPOS_VAL    As String = "IXCM"
    Const strFIVE_VAL   As String = "VLD"
    
    Dim strRoman        As String
    Dim strCurrRomanPos As String
    Dim strLetter1      As String
    Dim strLetter2      As String
    Dim intCurrPos      As Integer
    Dim intDigit        As Integer
    Dim intDigitPos     As Integer
    
    intCurrPos = 1
    strRoman = ""
    
    For intDigitPos = Len(pstrDecimalNumber) To 1 Step -1
        intDigit = Val(Mid$(pstrDecimalNumber, intDigitPos, 1))
        strCurrRomanPos = Mid$(strPOS_VAL, intCurrPos, 1)
        Select Case intDigit
            Case 9
                strLetter1 = strCurrRomanPos
                strLetter2 = Mid$(strPOS_VAL, intCurrPos + 1, 1)
            Case Is > 4
                strLetter1 = Mid$(strFIVE_VAL, intCurrPos, 1)
                strLetter2 = String$(intDigit - 5, strCurrRomanPos)
            Case 4
                strLetter1 = strCurrRomanPos
                strLetter2 = Mid$(strFIVE_VAL, intCurrPos, 1)
            Case Else
                strLetter1 = String$(intDigit, strCurrRomanPos)
                strLetter2 = ""
        End Select
        strRoman = strLetter1 & strLetter2 & strRoman
        intCurrPos = intCurrPos + 1
    Next

    ConvertToRoman = strRoman

End Function

